<html>

<head>
<meta charset="utf-8">

<style>
body{
    font-size: 14px;
    font-family: Helvetica;
    margin-left: 5%;
    margin-right: 5%;
}

a{
    color: #333;
}
a.menu{
    text-decoration: none;
}
a.menu:hover{
    background-color: #ccc;
}
a:visited{
    color: #333;
}

li{
    list-style-type: none;
}

.panel{
    position: absolute;
    top: 100;
    left: 10%;
    width: 70%;
    height: 300;
    background-color: #ccc;
    padding: 10;
}

button{
    background-color: #dadada;
    color: #113;
    border-style: solid;
    border-color: #000;
    border-width: 1px;
    border-radius: 3px;
    font-size: 1.2em;
}
button.btn-ls{
    font-size: 1em;
}

div.family{
    margin-top: 2em;
    display: none;
}

pre{
    font-family: Consolas, Courier New;
    color: #113;
    background: linear-gradient(to right, #ccc, #fff);
    border-width: 0 0 0 2;
    border-color: #aac;
    border-style: solid;
    margin-top: 2em;
}

pre.html{
    padding: 0.5em;
}

.tree{
    margin-left: 5em;
    padding: 1em;
    border-width: 0px;
    border-color: #333;
    border-style: solid;
}

code{
    font-family: Consolas, Courier New;
    color: #113;
    padding-left: 0.2em;
    padding-right: 0.2em;
}

code.file{
    background-color: #fff;
    font-weigth: bold;
    font-style: italic;
}

.up{
    font-size: 1.2em;
}
.down{
    font-size:0.8em;
}

</style>

</head>

<body onload="brython(1)">

<h1 style="text-align: center">Web Tree Viewer</h1>

<div style="display:table">
  <div style="display:table-row;">
    <div style="display:table-cell; width:200px; vertical-align:top;">
      <ul id="menu">
      </ul>
    </div>
    <div style="display:table-cell; width:1400px;" id="panel">
    </div>
  </div>
</div>

<script type="text/python">
"""\
This brython script is the web interface of pytreeview. 
Author: Yannick Parmentier
Date: 2017/01/23
"""
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import time, json
from browser import document, html, alert

def load_family(ev):
    global current
    if current is not None:
        document[current].style.display = "none"
        document <= document[current]
        document["a"+current].style.fontWeight = "normal"
    family_id = ev.target.num
    ev.target.style.fontWeight = "bold"
    document["panel"].clear()
    document["panel"] <= document[family_id]
    document[family_id].style.display="block"
    current = family_id

current = None

#Input: json files having the following format                         
#grammar  = { 'name':'demo', 'families':'fam.json', 'entries':'entries.json'}
#families = { 'n0Vn1':['n0Vn1_3','n0Vn1_4','n0Vn1_6'],
#             'n0V':['n0V_1']       
#           }
#entries  = { 'n0Vn1_3':{'sem':'@21(@23,@23)', 'iface':'X:@21,Y:@22', ...},
#             'n0Vn1_4':{'sem':'@12(@32,@32)', 'iface':'X:@12,Y:@22', ...},
#             'n0Vn1_6':{'sem':'@26(@24,@27)', 'iface':'X:@26,Y:@24', ... }
#           }
fake_qs2 = '?foo=%s' %time.time() #for auto-refresh
gdata = open('build/grammar.json'+fake_qs2).read()          
fdata = open('build/families.json'+fake_qs2).read()         
edata = open('build/entries.json'+fake_qs2).read()                   
grammar = json.loads(gdata)
families= json.loads(fdata)
entries = json.loads(edata)
                         
def show_tree(ev):
    fname  = ev.target.id.split('_')[1]       
    select = document["select_"+fname]
    treeid = select.options[select.selectedIndex].value
    featOff= False
    for elt in document.get(selector='input[type="checkbox"]'):
        if elt.id == 'featOff' and elt.checked:
             featOff = True                                
    fake_qs= '?foo=%s' %time.time()
    document["zone_" + fname].clear()
    #insert table for displaying trees
    table1  = html.TABLE(cellpadding='10')
    trace1  = ''
    trace2  = ''
    trace3  = ''
    for indclasse in range(len(entries[treeid]['trace'])):
        if indclasse < len(entries[treeid]['trace'])*1//3:
            trace1 += entries[treeid]['trace'][indclasse] + html.BR()
        elif indclasse < len(entries[treeid]['trace'])*2//3:
            trace2 += entries[treeid]['trace'][indclasse] + html.BR()
        else:
            trace3 += entries[treeid]['trace'][indclasse] + html.BR()
    table1 <= html.TR(html.TD(html.B('Trace:   ')+html.BR()))
    tcell1 = html.TD(trace1)
    tcell2 = html.TD(trace2)
    tcell3 = html.TD(trace3)
    table1 <= html.TR([tcell1, tcell2, tcell3])
    document["zone_" + fname] <= table1
    table  = html.TABLE(cellpadding='10')
    semf   = ''
    for subformula in entries[treeid]['sem'].split(')'):
        if subformula.strip() != '':
            semf += subformula + ')' + html.BR()
    semcell= html.TD(html.B('Semantics:')+html.BR()+html.BR()+semf)
    iface  = ''
    firstf = True
    for feat in sorted(entries[treeid]['iface'].split(',')):
        if feat.strip() != '':
            if not(firstf):
                iface += '   |   ' + '{:<6}'.format(feat.split(':')[0]) + ':' + '{:>6}'.format(feat.split(':')[1])                
            else:
                iface += '{:<6}'.format(feat.split(':')[0]) + ':' + '{:>6}'.format(feat.split(':')[1])
                firstf = False
    ifacell= html.TD(html.B('Interface:')+html.BR()+html.BR()+iface)
    row    = html.TR([semcell, ifacell])                     
    table <= row
    if featOff:
        table  <= html.TR(html.TD(html.B('Syntax:   ')+html.BR()+html.A('[TIKZ (no features)]', href='build/'+treeid+'.tex', style={'font-size':'11px'})+html.B('     ')+html.A('[Open PNG file in new tab (for zooming)]', href='build/'+treeid+'.png'+fake_qs, target='_blank', style={'font-size':'12px'})+html.BR()))
    else:
        table  <= html.TR(html.TD(html.B('Syntax:   ')+html.BR()+html.A('[TIKZ (no features)]', href='build/'+treeid+'.tex', style={'font-size':'11px'})+html.B('     ')+html.A('[Open PNG file in new tab (for zooming)]', href='build/'+treeid+'_feat.png'+fake_qs, target='_blank', style={'font-size':'12px'})+html.BR()))
    document["zone_" + fname] <= table
    if featOff:
        document["zone_" + fname] <= html.IMG(src='build/'+treeid+'.png'+fake_qs, style={'max-width':'100%'})
    else:
        document["zone_" + fname] <= html.IMG(src='build/'+treeid+'_feat.png'+fake_qs, style={'max-width':'100%'})

# main
for f in sorted(families.keys()):     
    newfam  = html.DIV(Class='family', id=f)
    document<= newfam                    
    newfam <= html.H1(f)
    sellab  = html.P('Select entry: ')
    sel     = html.SELECT(id="select_"+f)
    for e in families[f]:
        sel<= html.OPTION(e, value=e)
    sellab <= sel
    check   = html.INPUT(Type="checkbox", id='featOff')
    sellab <= '  Do not display features' + check          
    newfam <= sellab
    newfam <= html.DIV(Class="tree",id="zone_"+f)
    document["select_"+f].bind('click',show_tree)

# grammar name
document["menu"] <= html.H3('Grammar ' + html.BR() + grammar['name'])
document["menu"] <= html.H4(html.BR() + 'Families: ' + html.BR())
                    
for family in document.get(selector=".family"):
    # create a menu entry
    button = family.get(selector="h1")[0]
    anchor = html.A(button.text, Class="menu", href="#", id="a"+family.id)
    anchor.num = family.id
    anchor.bind("click", load_family)
    document["menu"] <= html.LI(anchor)    
    # hide the element
    family.style.display = "none"

</script>
<script src="web/brython.js"></script>
<script src="web/brython_stdlib.js"></script>
</body>
</html>
